#include "LPC17xx.h"
#include "ili9320.h"
#include "ili9320_ucgui.h"
#include "stdint.h"
/****************************************************************************
*     ƣGUI_CmpColor()
*     ܣжɫֵǷһ¡
* ڲcolor1		ɫֵ1
*		        color2		ɫֵ2
* ڲ1ʾͬ0ʾͬ
* ˵    
****************************************************************************/
#define  GUI_CmpColor(color1, color2)	( (color1&0x01) == (color2&0x01) )


/****************************************************************************
*     ƣu16 GUI_Color565(u32 RGB)
*     ܣRGBɫתΪ16λɫ
* ڲRGB  ɫֵ
* ڲ16λRGBɫֵ
* ˵    
* ÷i=GUI_Color565(0xafafaf);
****************************************************************************/
uint16_t GUI_Color565(uint32_t RGB)
{
  uint8_t  r, g, b;

  b = ( RGB >> (0+3) ) & 0x1f;		// ȡBɫĸ5λ
  g = ( RGB >> (8+2) ) & 0x3f;		// ȡGɫĸ6λ
  r = ( RGB >> (16+3)) & 0x1f;		// ȡRɫĸ5λ
   
  return( (r<<11) + (g<<5) + (b<<0) );		
}

/****************************************************************************
*     ƣvoid GUI_Text(u16 x, u16 y, u8 *str, u16 len,u16 Color, u16 bkColor)
*     ܣָʾַ
* ڲx      
*           y      
*           *str   ַ
*           len    ַ
*           Color  ַɫ
*           bkColorַɫ
* ڲ
* ˵    
* ÷GUI_Text(0,0,"0123456789",10,0x0000,0xffff);
****************************************************************************/
void GUI_Text(uint16_t x, uint16_t y, uint8_t *str, uint16_t len,uint16_t Color, uint16_t bkColor)
{
  uint8_t i;
  
  for (i=0;i<len;i++)
  {
    ili9320_PutChar((x+8*i),y,*str++,Color,bkColor);
  }
}

/****************************************************************************
*     ƣvoid GUI_Line(u16 x0, u16 y0, u16 x1, u16 y1,u16 color)
*     ܣָ껭ֱ
* ڲx0     A
*           y0     A
*           x1     B
*           y1     B
*           color  ɫ
* ڲ
* ˵    
* ÷GUI_Line(0,0,240,320,0x0000);
****************************************************************************/
void GUI_Line(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1,uint16_t color)
{
 	uint16_t x,y;
 	uint16_t dx;// = abs(x1 - x0);
 	uint16_t dy;// = abs(y1 - y0);

	if(y0==y1)
	{
		if(x0<=x1)
		{
			x=x0;
		}
		else
		{
			x=x1;
			x1=x0;
		}
  		while(x <= x1)
  		{
   			ili9320_SetPoint(x,y0,color);
   			x++;
  		}
  		return;
	}
	else if(y0>y1)
	{
		dy=y0-y1;
	}
	else
	{
		dy=y1-y0;
	}
 
 	if(x0==x1)
	{
		if(y0<=y1)
		{
			y=y0;
		}
		else
		{
			y=y1;
			y1=y0;
		}
  		while(y <= y1)
  		{
   			ili9320_SetPoint(x0,y,color);
   			y++;
  		}
  		return;
	}
	else if(x0 > x1)
 	{
		dx=x0-x1;
  		x = x1;
  		x1 = x0;
  		y = y1;
  		y1 = y0;
 	}
 	else
 	{
		dx=x1-x0;
  		x = x0;
  		y = y0;
 	}

 	if(dx == dy)
 	{
  		while(x <= x1)
  		{

   			x++;
			if(y>y1)
			{
				y--;
			}
			else
			{
   				y++;
			}
   			ili9320_SetPoint(x,y,color);
  		}
 	}
 	else
 	{
 		ili9320_SetPoint(x, y, color);
  		if(y < y1)
  		{
   			if(dx > dy)
   			{
    			int16_t p = dy * 2 - dx;
    			int16_t twoDy = 2 * dy;
    			int16_t twoDyMinusDx = 2 * (dy - dx);
    			while(x < x1)
    			{
     				x++;
     				if(p < 0)
     				{
      					p += twoDy;
     				}
     				else
     				{
      					y++;
      					p += twoDyMinusDx;
     				}
     				ili9320_SetPoint(x, y,color);
    			}
   			}
   			else
   			{
    			int16_t p = dx * 2 - dy;
    			int16_t twoDx = 2 * dx;
    			int16_t twoDxMinusDy = 2 * (dx - dy);
    			while(y < y1)
    			{
     				y++;
     				if(p < 0)
     				{
      					p += twoDx;
     				}
     				else
     				{
      					x++;
      					p+= twoDxMinusDy;
     				}
     				ili9320_SetPoint(x, y, color);
    			}
   			}
  		}
  		else
  		{
   			if(dx > dy)
   			{
    			int16_t p = dy * 2 - dx;
    			int16_t twoDy = 2 * dy;
	    		int16_t twoDyMinusDx = 2 * (dy - dx);
    			while(x < x1)
    			{
     				x++;
     				if(p < 0)
	     			{
    	  				p += twoDy;
     				}
     				else
     				{
      					y--;
	      				p += twoDyMinusDx;
    	 			}
     				ili9320_SetPoint(x, y,color);
    			}
   			}
	   		else
   			{
    			int16_t p = dx * 2 - dy;
    			int16_t twoDx = 2 * dx;
	    		int16_t twoDxMinusDy = 2 * (dx - dy);
    			while(y1 < y)
    			{
     				y--;
     				if(p < 0)
	     			{
    	  				p += twoDx;
     				}
     				else
     				{
      					x++;
	      				p+= twoDxMinusDy;
    	 			}
     				ili9320_SetPoint(x, y,color);
    			}
   			}
  		}
 	}
}

/****************************************************************************
*     ƣvoid GUI_Circle(u16 cx,u16 cy,u16 r,u16 color,u8 fill)
*     ܣָ껭Բ
* ڲ
* ڲ
* ˵    
* ÷
****************************************************************************/
void GUI_Circle(uint16_t cx,uint16_t cy,uint16_t r,uint16_t color,uint8_t fill)
{
	uint16_t x,y;
	int16_t delta,tmp;
	x=0;
	y=r;
	delta=3-(r<<1);

	while(y>x)
	{
		if(fill)
		{
			GUI_Line(cx+x,cy+y,cx-x,cy+y,color);
			GUI_Line(cx+x,cy-y,cx-x,cy-y,color);
			GUI_Line(cx+y,cy+x,cx-y,cy+x,color);
			GUI_Line(cx+y,cy-x,cx-y,cy-x,color);
		}
		else
		{
			ili9320_SetPoint(cx+x,cy+y,color);
			ili9320_SetPoint(cx-x,cy+y,color);
			ili9320_SetPoint(cx+x,cy-y,color);
			ili9320_SetPoint(cx-x,cy-y,color);
			ili9320_SetPoint(cx+y,cy+x,color);
			ili9320_SetPoint(cx-y,cy+x,color);
			ili9320_SetPoint(cx+y,cy-x,color);
			ili9320_SetPoint(cx-y,cy-x,color);
		}
		x++;
		if(delta>=0)
		{
			y--;
			tmp=(x<<2);
			tmp-=(y<<2);
			delta+=(tmp+10);
		}
		else
		{
			delta+=((x<<2)+6);
		}
	}
}

/****************************************************************************
*     ƣvoid GUI_Rectangle(u16 x0, u16 y0, u16 x1, u16 y1,u16 color,u8 fill)
*     ܣָ򻭾Σɫ
* ڲ
* ڲ
* ˵    
* ÷
****************************************************************************/
void GUI_Rectangle(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1,uint16_t color,uint8_t fill)
{
	if(fill)
	{
		uint16_t i;
		if(x0>x1)
		{
			i=x1;
			x1=x0;
		}
		else
		{
			i=x0;
		}
		for(;i<=x1;i++)
		{
			GUI_Line(i,y0,i,y1,color);
		}
		return;
	}
	GUI_Line(x0,y0,x0,y1,color);
	GUI_Line(x0,y1,x1,y1,color);
	GUI_Line(x1,y1,x1,y0,color);
	GUI_Line(x1,y0,x0,y0,color);
}

/****************************************************************************
*     ƣvoid  GUI_Square(u16 x0, u16 y0, u16 with, u16 color,u8 fill)
*     ܣָΣɫ
* ڲ
* ڲ
* ˵    
* ÷
****************************************************************************/
void  GUI_Square(uint16_t x0, uint16_t y0, uint16_t with, uint16_t color,uint8_t fill)
{
	GUI_Rectangle(x0, y0, x0+with, y0+with, color,fill);
}
